package net.conacom.servletrunner.impl;

/**
 * Copyright 1999,2002 by conacom GmbH, http://www.conacom.de
 * Copyright 1999-2002 Bernd Hohmann, hohmann@harddiskcafe.de
 * All rights reserved.
 * 
 * This software or implementation is free for commercial and non-commercial use.
 * No warranty is given about the functionality.
 */
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import net.conacom.servletrunner.main.*;
import net.conacom.servletrunner.util.*;
import net.conacom.servletrunner.sessionmanager.*;
/**
 * 26.06.02 ho: creation
 */
public class RequestDispatcher_Impl implements RequestDispatcher {
	private Servlet servlet = null;
	private String strQueryString[] = null;
	private ServletContainerConfig scc = null;
	private ServletInstance si = null;
/**
 * 
 */
public RequestDispatcher_Impl(Servlet servlet, String strQueryString[], ServletContainerConfig scc, ServletInstance si) {
	super();
	this.servlet = servlet;
	this.strQueryString = strQueryString;
	this.scc = scc;
	this.si = si;
}
/**
 * 
 */
public void forward(ServletRequest req, ServletResponse res) throws ServletException, IOException {
	// reset output buffer
	res.reset();
	// create a new request with changed QUERY_STRING and others
	HttpServletRequest_Impl reqNew = getNewRequest((HttpServletRequest_Impl) req);
	// execute the request
	servlet.service(reqNew, res);
	// this is a dummy call to set the "commited" flag and close all streams to prevent further writing
 	((ServletResponse_Impl) res)._getResponseData();
 	// dispose our temporary request
	reqNew.dispose();
}
/**
 * create a new HttpServletRequest for this instance
 */
private HttpServletRequest_Impl getNewRequest(HttpServletRequest_Impl req) {
	/**
	 * create a new HttpServletRequest for this instance
	 */
	Hashtable hshHeader = ((ServletRequest_Impl) req)._getHeader();
	Hashtable hshParams = (Hashtable) ((ServletRequest_Impl) req)._getParams().clone();
	ServletInputStream sis = ((ServletRequest_Impl) req)._getInputStream();
	HttpServletRequest_Impl reqNew = new HttpServletRequest_Impl(scc, si);
	// manipulate querystring and parameters
	hshHeader.put("QUERY_STRING", strQueryString);
	if (strQueryString != null) {
		if (strQueryString[0].indexOf('=') == -1 && strQueryString[0].indexOf('&') == -1) {
			hshParams.put(strQueryString[0], new String[] {""});
		} else {
			hshParams = HttpUtils.parseQueryString(strQueryString[0]);
		}
	}
	reqNew._initObject(hshHeader, hshParams, sis);
	return reqNew;
}
/**
 * 
 */
public void include(ServletRequest req, ServletResponse res) throws ServletException, IOException {
	/**
	 * this attributes must be set also (not if we're coming from a named dispatcher)
	 *
	 * javax.servlet.include.request_uri
	 * javax.servlet.include.context_path
	 * javax.servlet.include.servlet_path
	 * javax.servlet.include.path_info
	 * javax.servlet.include.query_string
	 */
	// create a new request with changed QUERY_STRING and others
	HttpServletRequest_Impl reqNew = getNewRequest((HttpServletRequest_Impl) req);
	// execute the request
	servlet.service(reqNew, res);
	// dispose our temporary request
	reqNew.dispose();
}
}