package net.conacom.servletrunner.impl;

/**
 * Copyright 1999,2002 by conacom GmbH, http://www.conacom.de
 * Copyright 1999-2002 Bernd Hohmann, hohmann@harddiskcafe.de
 * All rights reserved.
 * 
 * This software or implementation is free for commercial and non-commercial use.
 * No warranty is given about the functionality.
 */
import java.io.*;
import net.conacom.servletrunner.util.*;
/**
 * Provides an output stream for sending binary data to the
 * client. You can access an object of this class
 * by using the {@link ServletResponse.getOutputStream}
 * method.
 *
 * <p>This class is abstract and the servlet engine usually
 * extends and defines it. If you subclass this class,
 * you must implement the <code>java.io.OutputStream#write(int)</code>
 * method.
 *
 * 
 * @author 	Various
 * @version 	$Version$
 *
 * @see 	ServletResponse
 *
 */
/**
 * 21.03.02 ho: creation
 */
public class ServletOutputStream_Impl extends javax.servlet.ServletOutputStream {
	private ByteString bs = null;
public ServletOutputStream_Impl(ByteString bs) {
	super();
	this.bs = bs;
}
public void close() throws IOException {
	// does nothing because we need the byte buffer elsewhere
}
public void write(int i) throws IOException {
	bs.append((byte) i);
}
}