package net.conacom.servletrunner.main;

/**
 * Copyright 1999,2002 by conacom GmbH, http://www.conacom.de
 * Copyright 1999-2002 Bernd Hohmann, hohmann@harddiskcafe.de
 * All rights reserved.
 * 
 * This software or implementation is free for commercial and non-commercial use.
 * No warranty is given about the functionality.
 */
/**
 * contains some statistical data 
 *
 * 10.04.02 ho: runtime timing statistics
 * 21.03.02 ho: creation
 */
public class ServletContainerStatistics {
	// number of servletrequests total
	public long lngNbOfRequests = 0;
	// number of servletrequests which had an unhandled exception
	public long lngNbOfErrors = 0;
	// number of requests which used all initialized instances
	public long lngNbOfPeakRequests = 0;
	// number of requests which a currently running
	public int intCurrentRunningRequests = 0;
	// number of restarted instances
	public int intInstancesRestarted = 0;
	// smalled requestbuffer (servlet -> webserver) used
	public int intMinBufferSize = Integer.MAX_VALUE;
	// largest requestbuffer (servlet -> webserver) used
	public int intMaxBufferSize = Integer.MIN_VALUE;
	// arrays which contains statistic about which buffersize was used how many times
	public long lngBufferCnt[] = null;
	public double dblBufferGrid[] = null;
	// total time in request
	public long lngTotalTimeInRequest = 0;
	// total time in servlet
	public long lngTotalTimeInServlet = 0;
/**
 *
 */
public ServletContainerStatistics() {
	super();
	lngBufferCnt = new long[30];
	dblBufferGrid = new double[30];
	dblBufferGrid[0] = 1; // < 1k
	dblBufferGrid[1] = 2.5; // < 2.5k
	dblBufferGrid[2] = 5; // < 5k
	dblBufferGrid[3] = 7.5; // < 7.5k
	dblBufferGrid[4] = 10; // < 10k
	dblBufferGrid[5] = 15; // < 15k
	dblBufferGrid[6] = 20; // < 20k
	dblBufferGrid[7] = 25; // < 25k
	dblBufferGrid[8] = 30; // < 30k
	dblBufferGrid[9] = 35; // < 35k
	dblBufferGrid[10] = 40; // < 40k
	dblBufferGrid[11] = 45; // < 45k
	dblBufferGrid[12] = 50; // < 50k
	dblBufferGrid[13] = 60; // < 60k
	dblBufferGrid[14] = 70; // < 70k
	dblBufferGrid[15] = 80; // < 80k
	dblBufferGrid[16] = 90; // < 90k
	dblBufferGrid[17] = 100; // < 100k
	dblBufferGrid[17] = 120; // < 120k
	dblBufferGrid[18] = 140; // < 140k
	dblBufferGrid[19] = 160; // < 160k
	dblBufferGrid[20] = 180; // < 180k
	dblBufferGrid[21] = 190; // < 190k
	dblBufferGrid[22] = 200; // < 200k
	dblBufferGrid[23] = 225; // < 225k
	dblBufferGrid[24] = 250; // < 250k
	dblBufferGrid[25] = 275; // < 275k
	dblBufferGrid[26] = 300; // < 300k
	dblBufferGrid[27] = 350; // < 350k
	dblBufferGrid[28] = 400; // < 400k
	dblBufferGrid[29] = Double.MAX_VALUE; // anything else
	
}
}