package net.conacom.servletrunner.sessionmanager;

/**
 * Copyright 1999-2002 by conacom GmbH
 * Wilhelmshoeher Strasse 202, 60389 Frankfurt/Main, Germany
 * All rights reserved.
 * 
 * This software or implementation is free for commercial and non-commercial use.
 * No warranty is given about the functionality.
 */
import java.util.*;
import net.conacom.servletrunner.util.*;
/**
 * 09.04.02 ho: removed isValidSession(long)
 * 23.03.02 ho: creation
 */
public class SessionData {
	/**
	 * values which must NOT be stored by SessionStorage
	 * they are overwritten when the session is retrieved
	 */
	// new session ?
	public transient boolean blnIsNewSession = false;

	/**
	 * values which MUST be stored by SessionStorage
	 */
	// the session id
	public String strID = null;
	// session creation time (in MS since 1970)
	public long lngCreationTime = -1;
	// time last accessed (in MS since 1970)
	public long lngLastAccessedTime = -1;
	// time after we have to invalidate the sessioncontext (in MS) ?
	public long lngMaxInactiveInterval = -1;
	// the values
	public Hashtable hshValues = null;
/**
 * HttpSessionConfig - Konstruktorkommentar.
 */
public SessionData() {
	super();
}
/**
 * returns if a session is valid
 * @return boolean
 */
public boolean isValidSession() {
	if ((TimeFactory.getTime() - lngLastAccessedTime) > lngMaxInactiveInterval)
		return false;
	else
		return true;
}
}