package net.conacom.servletrunner.util;

/*
 * Copyright 1999-2002 by conacom GmbH
 * Wilhelmshoeher Strasse 202, 60389 Frankfurt/Main, Germany
 * All rights reserved.
 * 
 * This software or implementation is free for commercial and non-commercial use.
 * No warranty is given about the functionality.
 */
import java.util.*;
/**
 * a small event system for internal communication
 *
 * 16.06.02 ho: creation
 */
public class RunnerEventHandler {
	private static Vector vecListeners = new Vector();
/**
 * no instances please !
 */
private RunnerEventHandler() {
	super();
}
/**
 * 
 */
public final static void addListener(RunnerEventListener l) {
	// don't add twice
	if (vecListeners.indexOf(l) == -1)
		vecListeners.addElement(l);
}
/**
 * 
 */
public final static synchronized void postEvent(RunnerEvent e) {
	for (int i = 0; i < vecListeners.size(); i++) {
		RunnerEventListener l = (RunnerEventListener) vecListeners.elementAt(i);
		l.runnerEvent(e);
	}
}
/**
 * 
 */
public final static void removeAll() {
	vecListeners.removeAllElements();
}
/**
 * 
 */
public final static void removeListener(RunnerEventListener l) {
	vecListeners.removeElement(l);
}
}