package net.conacom.servletrunner.util;

/**
 * Copyright 1999-2002 by conacom GmbH
 * Wilhelmshoeher Strasse 202, 60389 Frankfurt/Main, Germany
 * All rights reserved.
 * 
 * This software or implementation is free for commercial and non-commercial use.
 * No warranty is given about the functionality.
 */
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
/**
 * testclass for RequestDispatcher#forward(...)
 *
 * 27.06.02 ho: creation
 */
public class TestForward extends HttpServlet {
/**
 * TestForward
 */
public TestForward() {
	super();
}
/**
 * 
 */
public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
	doService(req, res);
}
/**
 * 
 */
public void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
	doService(req, res);
}
/**
 * 
 */
private void doService(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
	PrintWriter pw = res.getWriter();
	pw.println("Output of forward/include value from class " + getClass().getName() + "<br>");
	pw.println("Press 'Back' in your browser to return to the test servlet");
	pw.println("<hr>");
	// list headers
	Vector v = new Vector();
	for (Enumeration e = req.getHeaderNames(); e.hasMoreElements();) {
		v.addElement((String) e.nextElement());
	}
	Helper.sortVector(v);
	pw.print("<b>Headers [getHeaderNames()]</b><pre>");
	for (int i = 0; i < v.size(); i++) {
		String s1 = (String) v.elementAt(i);
		String s2 = (String) req.getHeader(s1);
		pw.print("<li>" + s1 + "=" + s2);
	}
	pw.print("</pre>");
	pw.println("<hr>");
	// list parameters
	v = new Vector();
	for (Enumeration e = req.getParameterNames(); e.hasMoreElements();) {
		v.addElement((String) e.nextElement());
	}
	Helper.sortVector(v);
	pw.print("Parameterlist in QUERY_STRING:<pre>");
	for (int i = 0; i < v.size(); i++) {
		String s1 = (String) v.elementAt(i);
		String s2 = (String) req.getParameter(s1);
		pw.print("<li>" + s1 + "=" + s2);
	}
	pw.print("</pre>");
	// list attributes
	v = new Vector();
	for (Enumeration e = req.getAttributeNames(); e.hasMoreElements();) {
		v.addElement((String) e.nextElement());
	}
	Helper.sortVector(v);
	pw.print("<b>Attributes [req.getAttributeNames()]</b><pre>");
	for (int i = 0; i < v.size(); i++) {
		String s1 = (String) v.elementAt(i);
		Object o = req.getAttribute(s1);
		String s2 = o == null ? "(null)" : o.toString();
		pw.print("<li>" + s1 + "=" + s2);
	}
	pw.print("</pre>");
}
}