package net.conacom.servletrunner.util;

/**
 * Copyright 1999-2002 by conacom GmbH
 * Wilhelmshoeher Strasse 202, 60389 Frankfurt/Main, Germany
 * All rights reserved.
 * 
 * This software or implementation is free for commercial and non-commercial use.
 * No warranty is given about the functionality.
 */
import java.io.*;
import java.util.*;
import java.util.zip.*;
import javax.servlet.*;
import javax.servlet.http.*;
/**
 * a small testsuite
 *
 * 27.06.02 ho: test RequestDispatcher#forward(..) + #include(..)
 * 25.06.02 ho: test methods for API 2.3
 * 21.05.02 ho: list context methods
 * 19.04.02 ho: bigdata, fixed problem in ZipLoader
 * 07.04.02 ho: cookies
 * 25.03.02 ho: more options
 * 24.03.02 ho: creation
 */
public class TestServlet extends HttpServlet {
	private HttpServletRequest req = null;
	private HttpServletResponse res = null;
	private PrintWriter pw = null;
	private static final String HK = "\"";
/**
 * TestServlet - Konstruktorkommentar.
 */
public TestServlet() {
	super();
}
/**
 * testsuite
 */
private void action() throws ServletException, IOException {
	try {
		String strAction = req.getParameter("action");
		if (strAction == null)
			strAction = "";
		//
		if (strAction.equals("send_bytes")) {
			perfTestSendBytes();
			return;
		}
		if (strAction.equals("exec_redirect")) {
			actionExecRedirect();
			return;
		}
		if (strAction.equals("getimage")) {
			getImage();
			return;
		}
		//
		pw = res.getWriter();
		pw.println("<html>");
		pw.println("<head><title>Sokrates is working</title></head>");
		pw.println("<body>");
		pw.println(getServletContext().getServerInfo() + "<br>");
		pw.println("<hr>");
		//
		pw.println("Requested Action=" + HK + strAction + HK + "<br>");
		pw.println("Requestmethod=" + HK + req.getMethod() + HK);
		pw.println("<hr>");
		if (strAction.equals(""))
			actionListParameters();
		if (strAction.equals("list_parameters"))
			actionListParameters();
		if (strAction.equals("list_headers"))
			actionListHeaders();
		if (strAction.equals("list_req_attributes"))
			actionListRequestAttributes();
		if (strAction.equals("list_srv_attributes"))
			actionListServletAttributes();
		if (strAction.equals("list_cookies"))
			actionListCookies();
		if (strAction.equals("list_request_methods"))
			actionListRequestMethods();
		if (strAction.equals("list_context_methods"))
			actionListContextMethods();
		if (strAction.equals("test_formpost"))
			actionTestFormPost();
		if (strAction.equals("test_formupload"))
			actionTestFormUpload();
		if (strAction.equals("test_cookies"))
			actionTestCookies();
		if (strAction.equals("store_cookie"))
			actionStoreCookie();
		if (strAction.equals("test_sessions"))
			actionTestSessions();
		if (strAction.equals("store_sessiondata"))
			actionStoreSessionData();
		if (strAction.equals("list_sessiondata"))
			actionListSessionData();
		if (strAction.equals("test_redirect"))
			actionTestRedirect();
		if (strAction.equals("test_binary"))
			actionTestBinary();
		if (strAction.equals("test_choice"))
			actionTestChoice();
		if (strAction.equals("exec_choice"))
			actionExecChoice();
		if (strAction.equals("test_bigdata"))
			actionTestBigData();
		if (strAction.equals("test_include"))
			actionTestInclude();
		if (strAction.equals("test_forward"))
			actionTestForward();
		//
		pw.println("<hr>");
		writeNavigation();
		//
		pw.println("</body>");
		pw.println("</head>");
		pw.println("</html>");
	} catch (IOException e) {
	}
}
/**
 * 
 */
private void actionExecChoice() throws IOException {
	pw.println("<pre>You selected the following entries:");
	String s[] = req.getParameterValues("choice");
	if (s == null) {
		pw.print("Nothing");
	} else {
		for (int i = 0; i < s.length; i++) {
			pw.print("<li>" + s[i]);
		}
	}
	pw.print("</pre>");
}
/**
 * 
 */
private void actionExecRealPath() throws IOException {
	String s = req.getParameter("translate_path") + "\n";
	pw.print("<pre>");
	pw.print("Path entered   : " + s);
	pw.print("Path translated: " + getServletContext().getRealPath(s));
	pw.print("</pre>");
}
/**
 * 
 */
private void actionExecRedirect() throws IOException {
	res.sendRedirect(req.getParameter("redirect_url"));
}
/**
 * 
 */
private void actionListContextMethods() {
	ServletContext sc = getServletContext();
	pw.print("<b>List by methods (getServletContext()..) </b><pre>");
	pw.print("<li>getAttributeNames() = " + listEnum(sc.getAttributeNames()));
	pw.print("<li>getInitParameterNames() = " + listEnum(sc.getInitParameterNames()));
	pw.print("<li>getMajorVersion() = " + sc.getMajorVersion());
	pw.print("<li>getMimeType(\"\") = " + sc.getMimeType(""));
	pw.print("<li>getMinorVersion() = " + sc.getMinorVersion());
	pw.print("<li>getRealPath(\"\\\") = " + sc.getRealPath("\\"));
	pw.print("<li>getServerInfo() = " + sc.getServerInfo());
	pw.print("<li>getServletContextName() = " + sc.getServletContextName());
	pw.print("</pre>");
}
/**
 * 
 */
private void actionListCookies() {
	pw.print("<b>Cookies [getCookies()]</b>");
	Cookie c[] = req.getCookies();
	if (c == null) {
		pw.print("<pre>** no cookies defined **</pre>");
		return;
	}
	pw.print("<blockquote><pre>");
	for (int i = 0; i < c.length; i++) {
		Cookie co = c[i];
		pw.print("<li>");
		pw.println("Name   : " + co.getName());
		pw.println("Value  : " + co.getValue());
		pw.print("<i>");
		pw.println("MaxAge : " + co.getMaxAge());
		pw.println("Version: " + co.getVersion());
		pw.println("Comment: " + co.getComment());
		pw.println("Domain : " + co.getDomain());
		pw.println("Path   : " + co.getPath());
		pw.println("Secure : " + co.getSecure());
		pw.print("</i>");
		pw.print("</li>");
	}
	pw.println("</pre></blockquote>");
}
/**
 * 
 */
private void actionListHeaders() {
	Vector v = new Vector();
	for (Enumeration e = req.getHeaderNames(); e.hasMoreElements();) {
		v.addElement((String) e.nextElement());
	}
	Helper.sortVector(v);
	pw.print("<b>Headers [getHeaderNames()]</b><pre>");
	for (int i = 0; i < v.size(); i++) {
		String s1 = (String) v.elementAt(i);
		String s2 = (String) req.getHeader(s1);
		pw.print("<li>" + s1 + "=" + s2);
	}
	pw.print("</pre>");
}
/**
 * 
 */
private void actionListParameters() {
	Vector v = new Vector();
	for (Enumeration e = req.getParameterNames(); e.hasMoreElements();) {
		v.addElement((String) e.nextElement());
	}
	Helper.sortVector(v);
	pw.print("Parameterlist in QUERY_STRING:<pre>");
	for (int i = 0; i < v.size(); i++) {
		String s1 = (String) v.elementAt(i);
		String s2 = (String) req.getParameter(s1);
		pw.print("<li>" + s1 + "=" + s2);
	}
	pw.print("</pre>");
}
/**
 * 
 */
private void actionListRequestAttributes() {
	Vector v = new Vector();
	for (Enumeration e = req.getAttributeNames(); e.hasMoreElements();) {
		v.addElement((String) e.nextElement());
	}
	Helper.sortVector(v);
	pw.print("<b>Attributes [req.getAttributeNames()]</b><pre>");
	for (int i = 0; i < v.size(); i++) {
		String s1 = (String) v.elementAt(i);
		Object o = req.getAttribute(s1);
		String s2 = o == null ? "(null)" :o.toString();
		pw.print("<li>" + s1 + "=" + s2);
	}
	pw.print("</pre>");
}
/**
 * 
 */
private void actionListRequestMethods() {
	pw.print("<b>List by methods (HttpServletRequet) </b><pre>");
	pw.print("<li>getAuthType() = " + req.getAuthType());
	pw.print("<li>getAttributeNames() = " + listEnum(req.getAttributeNames()));
	pw.print("<li>getContextPath() = " + req.getContextPath());
	pw.print("<li>getCharacterEncoding() = " + req.getCharacterEncoding());
	pw.print("<li>getContentLength() = " + req.getContentLength());
	pw.print("<li>getContentType() = " + req.getContentType());
	pw.print("<li>getHeaderNames() = " + listEnum(req.getHeaderNames()));
	pw.print("<li>getLocale() = " + req.getLocale());
	pw.print("<li>getLocales() = " + listEnum(req.getLocales()));
	pw.print("<li>getMethod() = " + req.getMethod());
	pw.print("<li>getParameterNames() = " + listEnum(req.getParameterNames()));
	pw.print("<li>getPathInfo() = " + req.getPathInfo());
	pw.print("<li>getPathTranslated() = " + req.getPathTranslated());
	pw.print("<li>getProtocol() = " + req.getProtocol());
	pw.print("<li>getQueryString() = " + req.getQueryString());
	pw.print("<li>getRemoteAddr() = " + req.getRemoteAddr());
	pw.print("<li>getRemoteHost() = " + req.getRemoteHost());
	pw.print("<li>getRemoteUser() = " + req.getRemoteUser());
	pw.print("<li>getRequestedSessionId() = " + req.getRequestedSessionId());
	pw.print("<li>getRequestURI() = " + req.getRequestURI());
	pw.print("<li>getRequestURL() = " + req.getRequestURL());
	pw.print("<li>getScheme() = " + req.getScheme());
	pw.print("<li>getServerName() = " + req.getServerName());
	pw.print("<li>getServerPort() = " + req.getServerPort());
	pw.print("<li>getServletPath() = " + req.getServletPath());
	pw.print("<li>getUserPrincipal() = " + req.getUserPrincipal());
	pw.print("<li>isSecure() = " + req.isSecure());
	pw.print("<li>isRequestedSessionIdFromCookie() = " + req.isRequestedSessionIdFromCookie());
	pw.print("<li>isRequestedSessionIdFromURL() = " + req.isRequestedSessionIdFromURL());
	pw.print("<li>isRequestedSessionIdValid() = " + req.isRequestedSessionIdValid());
	pw.print("</pre>");
}
/**
 * 
 */
private void actionListServletAttributes() {
	Vector v = new Vector();
	for (Enumeration e = getServletContext().getAttributeNames(); e.hasMoreElements();) {
		v.addElement((String) e.nextElement());
	}
	Helper.sortVector(v);
	pw.print("<b>Attributes [getServletContext().getAttributeNames()]</b><pre>");
	for (int i = 0; i < v.size(); i++) {
		String s1 = (String) v.elementAt(i);
		Object o = getServletContext().getAttribute(s1);
		String s2 = o == null ? "(null)" : o.toString();
		pw.print("<li>" + s1 + "=" + s2);
	}
	pw.print("</pre>");
}
/**
 * 
 */
private void actionListSessionData() {
	pw.println("<b>Session Data [getSession()]</b>");
	HttpSession sess = req.getSession(false);
	if (sess == null) {
		pw.println("<pre>There is no session or the session is outdated. Create one first ! ('Test Sessions')</pre>");
		return;
	}
	//
	pw.println("<pre>");
	pw.println("ID           : " + sess.getId());
	pw.println("Created      : " + new Date(sess.getCreationTime()));
	pw.println("Last access  : " + new Date(sess.getLastAccessedTime()));
	pw.println("Invalid after: " + new Date(TimeFactory.getTime() + sess.getMaxInactiveInterval()));
	if (req.isRequestedSessionIdFromCookie()) {
		pw.println("Session-ID is: stored in Cookie");
	} else {
		pw.println("Session-ID is: stored in URL");
	}
	pw.println("Sessionmgr is: " + req.getAttribute(net.conacom.servletrunner.main.Runner.ATTR_PRAEFIX + "sessionmanager"));
	pw.println("</pre>");
	//
	pw.print("<blockquote><pre>");
	String s[] = sess.getValueNames();
	for (int i = 0; i < s.length; i++) {
		pw.print("<li>");
		pw.print(s[i] + " = " + sess.getValue(s[i]));
	}
	pw.println("</pre></blockquote>");
}
/**
 * 
 */
private void actionStoreCookie() {
	Cookie c = new Cookie(req.getParameter("cookie_name"), req.getParameter("cookie_value"));
	String s = null;
	//
	s = req.getParameter("cookie_age");
	if (s.length() != 0)
		c.setMaxAge(Integer.parseInt(s));
	//
	s = req.getParameter("cookie_version");
	if (s.length() != 0)
		c.setVersion(Integer.parseInt(s));
	//
	s = req.getParameter("cookie_comment");
	if (s.length() != 0)
		c.setComment(s);
	//
	s = req.getParameter("cookie_domain");
	if (s.length() != 0)
		c.setDomain(s);
	s = req.getParameter("cookie_path");
	if (s.length() != 0)
		c.setPath(s);
	//
	res.addCookie(c);
	pw.print("<pre>Cookie stored - try 'List Cookies' now</pre>");
}
/**
 * 
 */
private void actionStoreSessionData() {
	// the session was created 
	HttpSession sess = req.getSession(false);
	if (sess == null) {
		pw.println("OOPS - There is no session for us, but there should one !");
		return;
	}
	sess.putValue(req.getParameter("session_param"), req.getParameter("session_value"));
	//
	actionListSessionData();
}
/**
 * displays a lot of data
 */
private void actionTestBigData() {
	pw.println("<b>Testing big data</b><p>");
	pw.print("This is an HTML page with aprox. 256kb in size");
	StringBuffer strb1 = new StringBuffer(140000);
	StringBuffer strb2 = new StringBuffer(1024);
	for (int i = 0; i < 1024; i++)
		strb2.append("A");
	for (int i = 0; i < 256; i++) {
		strb1.append(i + 1);
		strb1.append(" ");
		strb1.append(strb2);
		strb1.append("\n");
	}
	pw.print("<pre>\n");
	pw.print(strb1.toString());
	pw.print("</pre>\n");
}
/**
 * displays a page with an image. the image is loaded by the browser by 
 * calling the servlet a second time with action 'getimage'.
 */
private void actionTestBinary() throws IOException {
	pw.println("You should see an image here<br>");
	pw.println("<img src=" + HK + res.encodeURL(req.getServletPath() + "?action=getimage" + HK + " name=" + HK + "testimage.jpg" + HK) + HK + ">");
}
/**
 * displays a page with a choice.
 */
private void actionTestChoice() throws IOException {
	pw.println("You should see a list. Select 1 or more entries<br>");
	pw.print("<form action=" + HK + res.encodeURL(req.getServletPath() + "?action=exec_choice") + HK);
	pw.print(" method=" + HK + "post" + HK + ">");
	//
	pw.println("<select name=" + HK + "choice" + HK + " size=" + HK + "5" + HK + " multiple>");
	pw.println("  <option value=" + HK + "01" + HK + ">Coffee</option>");
	pw.println("  <option value=" + HK + "02" + HK + ">Tea</option>");
	pw.println("  <option value=" + HK + "03" + HK + ">Water</option>");
	pw.println("  <option value=" + HK + "04" + HK + ">Beer</option>");
	pw.println("  <option value=" + HK + "05" + HK + ">Wine (red)</option>");
	pw.println("  <option value=" + HK + "06" + HK + ">Wine (white)</option>");
	pw.println("  <option value=" + HK + "07" + HK + ">Vodka</option>");
	pw.println("  <option value=" + HK + "08" + HK + ">Tequilla</option>");
	pw.println("  <option value=" + HK + "09" + HK + ">Sake</option>");
	pw.println("  <option value=" + HK + "10" + HK + ">Rum</option>");
	pw.println("</select>");
	//
	pw.print(" <input type=" + HK + "submit" + HK + " value=" + HK + "Send" + HK + ">");
	pw.print("</form>");
}
/**
 * displays a formpost page for cookies
 */
private void actionTestCookies() {
	pw.println("<b>Testing cookies</b><p>");
	pw.print("<form action=" + HK + res.encodeURL(req.getServletPath() + "?action=store_cookie") + HK);
	pw.print("method=" + HK + "post" + HK + ">\n");
	pw.print("<pre>\n");
	pw.print("Name    <input type=" + HK + "text" + HK + " name=" + HK + "cookie_name" + HK + " size=" + HK + "20" + HK + " maxlength=" + HK + "20" + HK + "> (text) \n");
	pw.print("Value   <input type=" + HK + "text" + HK + " name=" + HK + "cookie_value" + HK + " size=" + HK + "20" + HK + " maxlength=" + HK + "20" + HK + "> (text) \n");
	pw.print("Max age <input type=" + HK + "text" + HK + " name=" + HK + "cookie_age" + HK + " size=" + HK + "20" + HK + " maxlength=" + HK + "20" + HK + "> (numeric, seconds; -1 = Browsersession only) \n\n");
	pw.print("Version <input type=" + HK + "text" + HK + " name=" + HK + "cookie_version" + HK + " size=" + HK + "5" + HK + " maxlength=" + HK + "5" + HK + "> (numeric)\n");
	pw.print("Comment <input type=" + HK + "text" + HK + " name=" + HK + "cookie_comment" + HK + " size=" + HK + "20" + HK + " maxlength=" + HK + "20" + HK + "> (text) \n\n");
	pw.print("Domain  <input type=" + HK + "text" + HK + " name=" + HK + "cookie_domain" + HK + " size=" + HK + "20" + HK + " maxlength=" + HK + "20" + HK + "> (text, you must know what you're doing here !) \n");
	pw.print("Path    <input type=" + HK + "text" + HK + " name=" + HK + "cookie_path" + HK + " size=" + HK + "20" + HK + " maxlength=" + HK + "20" + HK + "> (text. you must know what you're doing here !) \n");
	pw.print("</pre>\n");
	pw.print("<input TYPE=" + HK + "submit" + HK + " value=" + HK + "Send" + HK + "></form>\n");
}
/**
 * displays a formpost page
 */
private void actionTestFormPost() {
	pw.println("<b>Testing forms</b><p>");
	pw.print("<form action=" + HK + res.encodeURL(req.getServletPath() + "?action=list_parameters") + HK);
	pw.print("method=" + HK + "post" + HK + ">\n");
	pw.print("Value 1: <input type=" + HK + "text" + HK + " name=" + HK + "form_field_1" + HK + " size=" + HK + "20" + HK + " maxlength=" + HK + "20" + HK + "><br>\n");
	pw.print("Value 2: <input type=" + HK + "text" + HK + " name=" + HK + "form_field_2" + HK + " size=" + HK + "20" + HK + " maxlength=" + HK + "20" + HK + "><br>\n");
	pw.print("<input TYPE=" + HK + "submit" + HK + " value=" + HK + "Send" + HK + "></form>\n");
}
/**
 * displays a formpost page with upload
 */
private void actionTestFormUpload() {
	pw.println("<b>Testing upload (multipart/form-data)</b><p>");
	pw.print("<form enctype=" + HK + "multipart/form-data" + HK + " action=" + HK + res.encodeURL(req.getServletPath() + "?action=list_parameters") + HK);
	pw.print("method=" + HK + "post" + HK + ">\n");
	pw.print("File: <input type=" + HK + "file" + HK + " name=" + HK + "form_field_1" + HK + " size=" + HK + "20" + HK + " maxlength=" + HK + "20" + HK + "><br>\n");
	pw.print("Text: <input type=" + HK + "text" + HK + " name=" + HK + "form_field_2" + HK + " size=" + HK + "20" + HK + " maxlength=" + HK + "20" + HK + ">\n");
	pw.print("<input TYPE=" + HK + "submit" + HK + " value=" + HK + "Send" + HK + "></form>\n");
}
/**
 * test forward and named dispatcher
 * 
 */
private void actionTestForward() throws ServletException, IOException {
	pw.println("if you see this, something went wrong (1).");
	RequestDispatcher rd = getServletContext().getNamedDispatcher("testforward?parameter=value");
	rd.forward(req, res);
	pw.println("if you see this, something went wrong (2).");
}
/**
 * test include
 */
private void actionTestInclude() throws ServletException, IOException {
	pw.println("<b>Testing include</b><br>");
	pw.println("include starts");
	pw.println("<hr><pre>");
	RequestDispatcher rd = getServletContext().getRequestDispatcher("net.conacom.servletrunner.util.TestForward?parameter=value");
	rd.include(req, res);
	pw.println("</pre><hr>");
	pw.println("include ends");
}
/**
 * tests a redirect
 */
private void actionTestRedirect() {
	pw.println("<b>Testing redirect</b><p>");
	pw.print("<form action=" + HK + res.encodeURL(req.getServletPath() + "?action=exec_redirect") + HK);
	pw.print("method=" + HK + "post" + HK + ">\n");
	pw.print("<pre>\n");
	pw.print("URL to redirect: <input type=" + HK + "text" + HK + " name=" + HK + "redirect_url" + HK + " size=" + HK + "50" + HK + " maxlength=" + HK + "50" + HK + "> (URL, path...) \n");
	pw.print("</pre>\n");
	pw.print("<input TYPE=" + HK + "submit" + HK + " value=" + HK + "Send" + HK + "></form>\n");
}
/**
 * displays a formpost page for sessiondata
 */
private void actionTestSessions() {
	pw.println("<b>Testing sessiondata</b><p>");
	HttpSession sess = req.getSession();
	if (sess.isNew()) {
		pw.println("A new session with ID '" + sess.getId() + "' was created for you");
	} else {
		pw.println("An existing session with ID '" + sess.getId() + "' is used");
	}
	pw.print("<form action=" + HK + res.encodeURL(req.getServletPath() + "?action=store_sessiondata") + HK);
	pw.print("method=" + HK + "post" + HK + ">\n");
	pw.print("<pre>\n");
	pw.print("Name    <input type=" + HK + "text" + HK + " name=" + HK + "session_param" + HK + " size=" + HK + "20" + HK + " maxlength=" + HK + "20" + HK + "> (text) \n");
	pw.print("Value   <input type=" + HK + "text" + HK + " name=" + HK + "session_value" + HK + " size=" + HK + "20" + HK + " maxlength=" + HK + "20" + HK + "> (text) \n");
	pw.print("</pre>\n");
	pw.print("<input TYPE=" + HK + "submit" + HK + " value=" + HK + "Send" + HK + "></form>\n");
}
protected void doDelete(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
	this.req = req;
	this.res = res;
	action();
}
protected void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
	this.req = req;
	this.res = res;
	action();
}
protected void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
	this.req = req;
	this.res = res;
	action();
}
protected void doPut(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
	this.req = req;
	this.res = res;
	action();
}
/**
 * returns the binary data with an image. we try the local directory and then the RUNNER.JAR
 * in version 1.2 we will delegate this to the servletcontext getRessource()
 */
private void getImage() throws IOException {
	String strFile = "testpic.jpg";
	ZipFile zf = null;
	InputStream in = null;
	long lngSize = -1;
	File flIn = new File(strFile);
	try {
		if (flIn.exists()) {
			lngSize = flIn.length();
			in = new FileInputStream(flIn);
		} else {
			zf = new ZipFile(new File("runner.jar"));
			ZipEntry ze = zf.getEntry(strFile);
			if (ze != null) {
				in = zf.getInputStream(ze);
				lngSize = ze.getSize();
			}
		}
		res.setContentType(getServletContext().getMimeType(strFile));
		res.setContentLength((int) lngSize);
		//
		ByteString bs = new ByteString((int) lngSize);
		byte[] buffer = new byte[512];
		int i = -1;
		while ((i = in.read(buffer)) != -1)
			bs.append(buffer, 0, i);
		res.getOutputStream().write(bs.getByteArray());
	} catch (ZipException e) {
		res.sendError(0, "Cannot find " + strFile);
		return;
	} catch (IOException e) {
		res.sendError(0, "Cannot find " + strFile);
		return;
	} finally {
		Helper.close(in);
		Helper.close(zf);
		res.getOutputStream().flush();
		res.getOutputStream().close();
	}
}
/**
 * lists and enumeration
 * @param e java.util.Enumeration
 */
private String listEnum(Enumeration e) {
	StringBuffer strb = new StringBuffer();
	strb.append("{");
	while (e.hasMoreElements()) {
		strb.append(e.nextElement());
		if (e.hasMoreElements())
			strb.append(",");
	}
	strb.append("}");
	return strb.toString();
}
/**
 * returns a number of chars on a action=send_bytes request
 * ?action=send_bytes&size={number of bytes to return}
 */
private void perfTestSendBytes() throws IOException {
	String s = req.getParameter("size");
	int i = -1;
	try {
		i = Integer.parseInt(s);
	} catch (NumberFormatException e) {
		throw new net.conacom.servletrunner.main.RunnerException("Illegal 'size' argument");
	}
	res.getOutputStream().write(new byte[i]);
}
/**
 * generates a button with form action post
 * @param strURL java.lang.String
 * @param strLabel java.lang.String
 */
private void writeButtonPOST(String strLabel, String strAction) {
	pw.print("<form action=" + HK + res.encodeURL(req.getServletPath() + "?" + strAction) + HK);
	pw.print(" method=" + HK + "post" + HK + ">");
	pw.print(" <input type=" + HK + "submit" + HK + " value=" + HK + strLabel + HK + ">");
	pw.print("</form>");
}
/**
 * 
 */
private void writeNavigation() {
	pw.print("<table cellspacing=0 cellpadding=0 border=0>\n");
	pw.print("<tr>\n");
	pw.print("<td>");
	writeButtonPOST("List Parameters", "action=list_parameters");
	pw.print("</td>\n<td>");
	writeButtonPOST("List Headers", "action=list_headers");
	pw.print("</td>\n<td>");
	writeButtonPOST("List Request-Attributes", "action=list_req_attributes");
	pw.print("</td>\n<td>");
	writeButtonPOST("List Servlet-Attributes", "action=list_srv_attributes");
	pw.print("</td>\n");
	pw.print("</tr></table>");
	//
	pw.print("<table cellspacing=0 cellpadding=0 border=0>\n");
	pw.print("<tr>\n");
	pw.print("<td>");
	writeButtonPOST("List Request Methods", "action=list_request_methods");
	pw.print("</td>\n<td>");
	writeButtonPOST("List Context Methods", "action=list_context_methods");
	pw.print("</td>\n<td>");
	writeButtonPOST("List Cookies", "action=list_cookies");
	pw.print("</td>\n<td>");
	writeButtonPOST("List Sessiondata", "action=list_sessiondata");
	pw.print("</td>\n");
	pw.print("</tr></table>");
	//
	pw.print("<table cellspacing=0 cellpadding=0 border=0>\n");
	pw.print("<tr>\n");
	pw.print("<td>");
	writeButtonPOST("Test Form", "action=test_formpost");
	pw.print("</td>\n<td>");
	/*
	writeButtonPOST("Test Upload", "action=test_formupload");
	pw.print("</td>\n<td>");
	*/
	writeButtonPOST("Test Cookies", "action=test_cookies");
	pw.print("</td>\n<td>");
	writeButtonPOST("Test Sessions", "action=test_sessions");
	pw.print("</td>\n<td>");
	writeButtonPOST("Test Redirect", "action=test_redirect");
	pw.print("</td>\n<td>");
	writeButtonPOST("Test Binary", "action=test_binary");
	pw.print("</td>\n<td>");
	writeButtonPOST("Test Choice", "action=test_choice");
	pw.print("</td>\n<td>");
	writeButtonPOST("Test BigData", "action=test_bigdata");
	pw.println("</td>\n");
	pw.println("</tr></table>");
	//
	pw.print("<table cellspacing=0 cellpadding=0 border=0>\n");
	pw.print("<tr>\n");
	pw.print("<td>");
	/*
	writeButtonPOST("Test Upload", "action=test_formupload");
	pw.print("</td>\n<td>");
	*/
	writeButtonPOST("Test Forward", "action=test_forward");
	pw.print("</td>\n<td>");
	writeButtonPOST("Test Include", "action=test_include");
	pw.println("</td>\n");
	pw.println("</tr></table>");
}
}