package net.conacom.servletrunner.util;

/*
 * Copyright 1999-2002 by conacom GmbH
 * Wilhelmshoeher Strasse 202, 60389 Frankfurt/Main, Germany
 * All rights reserved.
 * 
 * This software or implementation is free for commercial and non-commercial use.
 * No warranty is given about the functionality.
 */
/*
 * 03.04.02 ks: impl added.
 * 22.03.02 ho: creation
 */
/**
 * provides time based services.  By default it takes the current system time.  Other implementations 
 * should extend this class and be set with setTimeFactoryImpl().
 */
public abstract class TimeFactory extends Application {
	private static TimeFactory tfImpl;
protected TimeFactory() {
	super();
}
/**
 * 
 */
public void dispose() {
	blnDisposed = true;
}
/**
 * returns the timenormal
 */
public static long getTime() {
	if (tfImpl == null)
		return System.currentTimeMillis();
	return tfImpl.getTimeImpl();
}
/**
 * returns the timenormal
 */
protected abstract long getTimeImpl();
/**
* Diese Methode wurde in VisualAge erstellt.
* @param tf net.conacom.servletrunner.util.TimeFactory
*/
public static void setTimeFactoryImpl(TimeFactory tf) {
	tfImpl = tf;
}
}